//  Конфиг для TRX Raisin
//  Одна ПЧ 9.216MHz, гетеродины не переключаемые, 

#ifndef CONFIG_SW_H
#define CONFIG_SW_H

//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
//                  необходимо раскоментировать требуемую моду (только одну!)
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

// режим прямого преобразования. при приеме частота VFO формируется на CLK0
// при передаче частота VFO на CLK1 сдвинутая на частоту тона cw
//#define MODE_DC

// режим прямого преобразования с формированием квадратур
// при приеме и передаче SSB частота формируется на выводах CLK0,CLK1 со сдвигом фаз 90град
// при передаче CW частота на CLK2 сдвинутая на частоту тона cw
// Минимальная частота настройки 2MHz (по даташиту 4MHz) может зависеть от экземпляра Si5351
//#define MODE_DC_QUADRATURE

// супергетеродин с одной ПЧ. первый гетеродин всегда выше частоты приема
// боковая полоса выбирается установкой второго гетеродина на нижний/верхний скат фильтра
// первый гетеродин всегда на CLK0, второй - CLK1
#define MODE_SUPER

// Частоты 2го гетеродина в детекторе SSB для архитектуры MODE_SUPER
#define BFO_LSB   9216650L+300
#define BFO_USB   9214250L-300

// для супергетеродина MODE_SUPER надо определить константами что будет 
// на выходе синтезатора в разных режимах работы
// VFO/BFO - первый и второй гетеродины, 
// CWTX - cw-сигнал на частоте передачи
// CWIF - cw-сигнал на частоте ПЧ (соответствует частоте принимаемого тона cw)
// 0 - отключенный выход
// задавайте множители в обычной нотации. например 2*VFO, 4*VFO, 2*BFO, 2*CWTX и тп

#define CLK0_RX         VFO
#define CLK1_RX         BFO
#define CLK2_RX         0

#define CLK0_TX_CW      0
#define CLK1_TX_CW      0
#define CLK2_TX_CW      CWTX

#define CLK0_TX_SSB     VFO
#define CLK1_TX_SSB     BFO
#define CLK2_TX_SSB     0

#endif
